function VMachine_OnLoad()
    this:RegisterEvent("VARIABLES_LOADED");
    this:RegisterEvent("TRADE_SHOW");
    SlashCmdList["VMachine"] = VMachine_Slash_Handler;
    SLASH_VMachine1 = "/VM";
    SLASH_VMachine2 = "/VMachine";
end

function VMachine_OnEvent(event)
    if (event == "VARIABLES_LOADED") then
        VM_LoadVars()
    elseif (event == "TRADE_SHOW") then
        VM_Trade()
    end
end

function VMachine_Slash_Handler(msg)
    argv = {};
    for arg in string.gmatch(string.lower(msg), '[%a%d%-%.]+') do
        table.insert(argv, arg);
    end
    if (argv[1] == "on") then
        VMDB["VMon"] = 1
        VM_ChatMsg("VM now turned on!")
    elseif (argv[1] == "off") then
        VMDB["VMon"] = 0
        VM_ChatMsg("VM now turned off!")
    elseif (argv[1] == "exe") then
        VM_ChatMsg("Trading manually ... currently not working :(")
        VM_test()
    elseif (argv[1] == "reset") then
        if (argv[2]) then
            if (argv[2] == "on") then
                VMDB["Reset_onlog"] = 1
                VM_ChatMsg("Last trade setting will not be saved when you logout. VMachine will default to autotrade disabled!")
            elseif (argv[2] == "off") then
                VMDB["Reset_onlog"] = 0
                VM_ChatMsg("Last trade setting will be saved when you logout.")
            end
        else
            VM_ChatMsg("Please specify if u want to turn reset upon log on or off (/VM reset on)")
        end
    else
        if (argv[1] == nil) then
            VMachine_Help()
        else
            VM_ChatMsg("Invalid command: " .. argv[1] .. ". Type /VM for more info")
        end
    end
end

function VM_Trade()
    localizedClass, englishClass = UnitClass("NPC")
        if (VMDB["VMon"] == 1) then
            Player = TradeFrameRecipientNameText:GetText()
            VMDB["T_loc"] = 6
            if (englishClass == "MAGE") then
                SendChatMessage("Please make your own Food and Water!", "WHISPER", nil, Player)
            end
            if (englishClass == "WARRIOR") then
                Food_trans(3,0) -- First number is amount of stacks of food to give second is the amount of stacks of water to give
            end
            if (englishClass == "ROGUE") then
                Food_trans(3,0)
            end
            if (englishClass == "DRUID") then
                Food_trans(1,3)
            end
            if (englishClass == "PALADIN") then
                Food_trans(1,3)
            end
            if (englishClass == "PRIEST") then
                Food_trans(1,3)
            end
            if (englishClass == "SHAMAN") then
                Food_trans(1,3)
            end
            if (englishClass == "HUNTER") then
                Food_trans(2,1)
            end
            if (englishClass == "WARLOCK") then
                Food_trans(1,1)
            end
        end
end

function VM_test()
end

function Food_trans(Foodcount,Watercount)
	if (Foodcount >= 1) then
		for i=table.maxn(VM_Food_DB),1,-1 do
			for b=0,4 do 
				if Foodcount >= 1 then
					for s=1,GetContainerNumSlots(b) do 
						if (GetContainerItemLink(b,s)) then 
							if (string.find(GetContainerItemLink(b,s), VM_Food_DB[i])) then
								local texture, itemCount, locked, quality, readable = GetContainerItemInfo(b,s)
								if (locked ~= 1) then
									PickupContainerItem(b,s)
									for j=1,6 do
										if GetTradePlayerItemLink(j) == nil then
											ClickTradeButton(j)
										end
									end
									Foodcount = Foodcount -1
								end
							end
						end
					end
				end
			end
		end
	end
	if (Watercount >= 1) then
		for i=table.maxn(VM_Drink_DB),1,-1 do
			for b=0,4 do 
				if Watercount >= 1 then
					for s=1,GetContainerNumSlots(b) do 
						if (GetContainerItemLink(b,s)) then 
							if (string.find(GetContainerItemLink(b,s), VM_Drink_DB[i])) then
								local texture, itemCount, locked, quality, readable = GetContainerItemInfo(b,s)
								if (locked ~= 1) then
									PickupContainerItem(b,s)
									for j=1,6 do
										if GetTradePlayerItemLink(j) == nil then
											ClickTradeButton(j)
										end
									end
									Watercount = Watercount -1
								end
							end
						end
					end
				end
			end
		end
	end
	ClearCursor()
end

function VMachine_Help()
    VM_ChatMsg("VMachine Commands");
    VM_ChatMsg("----------------------------------");
    VM_ChatMsg("/VM on - Turns trading on.");
    VM_ChatMsg("/VM off - Turns trading off.");
    VM_ChatMsg("/VM exe - Manualy executes the trading function.");
    VM_ChatMsg("/VM reset on - Last trade setting will be saved when you logout.");
    VM_ChatMsg("/VM reset off - Last trade setting will not be saved when you logout. VMachine will default to autotrade disabled!");
end

function VM_ChatMsg(msg)
    if(DEFAULT_CHAT_FRAME) then
        DEFAULT_CHAT_FRAME:AddMessage("|cffffffff" .. msg);
    end
end

function VM_LoadVars()
    if (VMDB == nil) then
        VMDB = {}
    end
    if (VMDB["VMon"] == nil) then
        VMDB["VMon"] = 0
    end
    if (VMDB["Reset_onlog"] == nil) then
        VMDB["Reset_onlog"] = 1
    end
    if (VMDB["Reset_onlog"] == 1) then
        VMDB["VMon"] = 0
    end
    if (VMDB["VMon"] == 0) then
        VM_ChatMsg("VMachine loaded! Type /VM on or VM off to turn trading on or off. Currently auto trading is disabled!");
    end
    if (VMDB["VMon"] == 1) then
        VM_ChatMsg("VMachine loaded! Type /VM on or VM off to turn trading on or off. Currently auto trading is enabled!");
    end
    if (VMDB["VMFood"] == nil) then
        VMDB["VMFood"] = 0
    end
    if (VMDB["VMWater"] == nil) then
        VMDB["VMWater"] = 0
    end
    VM_Food_DB = {}
	VM_Food_DB[1] = "Conjured Muffin"
	VM_Food_DB[2] = "Conjured Bread"
	VM_Food_DB[3] = "Conjured Rye"
	VM_Food_DB[4] = "Conjured Pumpernickel"
	VM_Food_DB[5] = "Conjured Sourdough"
	VM_Food_DB[6] = "Conjured Sweet Roll"
	VM_Food_DB[7] = "Conjured Cinnamon Roll"
	VM_Food_DB[8] = "Conjured Croissant"
    VM_Drink_DB = {}
	VM_Drink_DB[1] = "Conjured Water"
	VM_Drink_DB[2] = "Conjured Fresh Water"
	VM_Drink_DB[3] = "Conjured Purified Water"
	VM_Drink_DB[4] = "Conjured Spring Water"
	VM_Drink_DB[5] = "Conjured Mineral Water"
	VM_Drink_DB[6] = "Conjured Sparkling Water"
	VM_Drink_DB[7] = "Conjured Crystal Water"
	VM_Drink_DB[8] = "Conjured Mountain Spring Water"
	VM_Drink_DB[9] = "Conjured Glacier Water"
end
